


-- disenchanting support


-- WORK IN PROGRESS!!

--[[
	Dust 	Essence 	Shard 	Craftable
Sources
iLvl 	Result 	Prob 	Qty 	Result 	Prob 	Qty 	Result 	Prob
6-15 	[Strange Dust] 	20% 	1-2x 		[Lesser Magic Essence] 	80% 	1-2x 					[17]
16-20 	[Strange Dust] 	20% 	2-3x 	[Greater Magic Essence] 	75% 	1-2x 	[Small Glimmering Shard] 	5% 	[18]
21-25 	[Strange Dust] 	15% 	4-6x 	[Lesser Astral Essence] 	75% 	1-2x 	[Small Glimmering Shard] 	10% 	[19]
26-30 	[Soul Dust] 	20% 	1-2x 	[Greater Astral Essence] 	75% 	1-2x 	[Large Glimmering Shard] 	5% 	[20]
31-35 	[Soul Dust] 	20% 	2-5x 	[Lesser Mystic Essence] 	75% 	1-2x 	[Small Glowing Shard] 	5% 	[21]
36-40 	[Vision Dust] 	20% 	1-2x 	[Greater Mystic Essence] 	75% 	1-2x 	[Large Glowing Shard] 	5% 	[22]
41-45 	[Vision Dust] 	20% 	2-5x 	[Lesser Nether Essence] 	75% 	1-2x 	[Small Radiant Shard] 	5% 	[23]
46-50 	[Dream Dust] 	20% 	1-2x 	[Greater Nether Essence] 	75% 	1-2x 	[Large Radiant Shard] 	5% 	[24]
51-55 	[Dream Dust] 	22% 	2-5x 	[Lesser Eternal Essence] 	75% 	1-2x 	[Small Brilliant Shard] 	3% 	[25]
56-60 	[Illusion Dust] 	22% 	1-2x 	[Greater Eternal Essence] 	75% 	1-2x 	[Large Brilliant Shard] 	3% 	[26]
61-65 	[Illusion Dust] 	22% 	2-5x 	[Greater Eternal Essence] 	75% 	2-3x 	[Large Brilliant Shard] 	3% 	[27]
66-99 	[Arcane Dust] 	22% 	2-3x 	[Lesser Planar Essence] 	75% 	2-3x 	[Small Prismatic Shard] 	3% 	[28]
100-120 	[Arcane Dust] 	22% 	2-5x 	[Greater Planar Essence] 	75% 	1-2x 	[Large Prismatic Shard] 	3% 	[29]
121-151 	[Infinite Dust] 	22% 	1-2x 	[Lesser Cosmic Essence] 	75% 	1-2x 	[Small Dream Shard] 	3% 	[30]
152-200 	[Infinite Dust] 	22% 	2-5x 	[Greater Cosmic Essence] 	75% 	1-2x 	[Dream Shard] 	3% 	[31]
Rare

    * Shards and crystals disenchanted from rare items are always 1x quantity.

iLvl 	Result 	Prob
11-25 	[Small Glimmering Shard] 	100%
26-30 	[Large Glimmering Shard] 	100%
31-35 	[Small Glowing Shard] 	100%
36-40 	[Large Glowing Shard] 	100%
41-45 	[Small Radiant Shard] 	100%
46-50 	[Large Radiant Shard] 	100%
51-55 	[Small Brilliant Shard] 	100%
56-65 	[Large Brilliant Shard] 	99.5%
[Nexus Crystal] 	0.5%
66-99 	[Small Prismatic Shard] 	99.5%
[Nexus Crystal] 	0.5%
100-120 	[Large Prismatic Shard] 	99.5%
[Void Crystal] 	0.5%
121-164 	[Small Dream Shard] 	99.5%
[Abyss Crystal] 	0.5%
165+ 	[Dream Shard] 	99.5%
[Abyss Crystal] 	0.5%
Epic

    * Except for iLevel 76-80 weapons, weapons and armor share the same probabilities.
    * All epic items have 100% chance of DE into the item listed for their level.

iLvl 	Result 	Qty 	Notes
40-45 	[Small Radiant Shard] 	2-4x
46-50 	[Large Radiant Shard] 	2-4x
51-55 	[Small Brilliant Shard] 	2-4x
56-60 	[Nexus Crystal] 	1x
61-80 	[Nexus Crystal] 	1-2x 	76-80 Weapons: 33% 1x, 67% 2x
95-100 	[Void Crystal] 	1-2x
105-164 	[Void Crystal] 	1-2x 	33% 1x, 67% 2x
165-200 	[Abyss Crystal] 	1x
201+ 	[Abyss Crystal] 	1-2x

]]


-- disabled till it's fleshed out more
local enabled = false


do
	local reagentID = {
		["[Arcane Dust]"]= 22445,
		["[Dream Dust]"]= 11176,
		["[Soul Dust]"] = 11083,
		["[Strange Dust]"] = 10940,
		["[Vision Dust]"] = 11137,
		["[Illusion Dust]"] = 16204,
		["[Infinite Dust]"] = 34054,

		["[Dream Shard]"] = 34052,
		["[Greater Astral Essence]"] = 11082,
		["[Greater Cosmic Essence]"] = 34055,
		["[Greater Eternal Essence]"] = 16203,
		["[Greater Magic Essence]"] = 10939,
		["[Greater Mystic Essence]"] = 11135,
		["[Greater Nether Essence]"] = 11175,
		["[Greater Planar Essence]"] = 22446,

		["[Large Brilliant Shard]"] = 14344,
		["[Large Glimmering Shard]"]  = 11084,
		["[Large Glowing Shard]"]  = 11139,
		["[Large Prismatic Shard]"]  = 22449,
		["[Large Radiant Shard]"]  = 11178,
		["[Lesser Astral Essence]"] = 10998,
		["[Lesser Cosmic Essence]"] = 34056,
		["[Lesser Eternal Essence]"] = 16202,
		["[Lesser Magic Essence]"]= 10938,
		["[Lesser Mystic Essence]"] = 11134,
		["[Lesser Nether Essence]"] = 11174,
		["[Lesser Planar Essence]"] = 22447,

		["[Small Brilliant Shard]"]  = 14343,
		["[Small Dream Shard]"] = 34053,
		["[Small Glimmering Shard]"] = 10978,
		["[Small Glowing Shard]"] = 11138,
		["[Small Prismatic Shard]"] = 22448,
		["[Small Radiant Shard]"] = 11177,

		["[Nexus Crystal]"] = 20725,
		["[Abyss Crystal]"] = 34057,
		["[Void Crystal]"] = 22450,
	}



	local reagentSourceTable = {
		["armor"] = {
			[15] = "[Strange Dust] 	80% 	1-2x 		[Lesser Magic Essence] 	20% 	1-2x",
			[20] = "[Strange Dust] 	75% 	2-3x 	[Greater Magic Essence] 	20% 	1-2x 	[Small Glimmering Shard] 	5% ",
			[25] = "[Strange Dust] 	75% 	4-6x 	[Lesser Astral Essence] 	15% 	1-2x 	[Small Glimmering Shard] 	10%",
			[30] = "[Soul Dust] 	75% 	1-2x 	[Greater Astral Essence] 	20% 	1-2x 	[Large Glimmering Shard] 	5%",
			[35] = "[Soul Dust] 	75% 	2-5x 	[Lesser Mystic Essence] 	20% 	1-2x 	[Small Glowing Shard] 	5%",
			[40] = "[Vision Dust] 	75% 	1-2x 	[Greater Mystic Essence] 	20% 	1-2x 	[Large Glowing Shard] 	5%",
			[45] = "[Vision Dust] 	75% 	2-5x 	[Lesser Nether Essence] 	20% 	1-2x 	[Small Radiant Shard] 	5%",
			[50] = "[Dream Dust] 	75% 	1-2x 	[Greater Nether Essence] 	20% 	1-2x 	[Large Radiant Shard] 	5%",
			[55] = "[Dream Dust] 	75% 	2-5x 	[Lesser Eternal Essence] 	20% 	1-2x 	[Small Brilliant Shard] 	5%",
			[60] = "[Illusion Dust] 	75% 	1-2x 	[Greater Eternal Essence] 	20% 	1-2x 	[Large Brilliant Shard] 	5%",
			[65] = "[Illusion Dust] 	75% 	2-5x 	[Greater Eternal Essence] 	20% 	2-3x 	[Large Brilliant Shard] 	5%",
			[80] = "[Arcane Dust] 	75% 	1-3x 	[Lesser Planar Essence] 	22% 	1-3x 	[Small Prismatic Shard] 	3%",
			[99] = "[Arcane Dust] 	75% 	2-3x 	[Lesser Planar Essence] 	22% 	2-3x 	[Small Prismatic Shard] 	3%",
			[120] = "[Arcane Dust] 	75% 	2-5x 	[Greater Planar Essence] 	22% 	1-2x 	[Large Prismatic Shard] 	3%",
			[151] = "[Infinite Dust] 	75% 	1-2x 	[Lesser Cosmic Essence] 	22% 	1-2x 	[Small Dream Shard] 	3%",
			[200] = "[Infinite Dust] 	75% 	2-5x 	[Greater Cosmic Essence] 	22% 	1-2x 	[Dream Shard] 	3%",
		}
	}


	local disenchantTable = { }


	local function BuildReagentTables()
		local armor = reagentSourceTable.armor;
		local armorTable = {}
		local baseLevel = 15
		local newTable

		for level=15,250 do
			local line

			if armor[level] then
				baseLevel = level
				newTable = {}

				line = armor[baseLevel]

				armorTable[level] = newTable

				local dustName, dustPercent, dustMin, dustMax, essenceName, essentPercent, essenceMin, essenceMax, shardName, shardPercent = string.match(line, "(%b[]) (%d+)% (%d)-(%d)x  (%b[]) (%d+)% (%d)-(%d)x (%b[]) (%d+)%")

				armorTable[level].dustCount = tonumber(dustPercent)/ 100 * (tonumber(dustMin) + tonumber(dustMax)) / 2
				armorTable[level].dustID = reagentID[dustName]

				armorTable[level].essenceCount = tonumber(essencePercent)/ 100 * (tonumber(essenceMin) + tonumber(eccenceMax)) / 2
				armorTable[level].essenceID = reagentID[essenceName]

				if shardName then
					armorTable[level].shardCount = tonumber(shardPercent)/ 100 * (tonumber(shardMin) + tonumber(shardMax)) / 2
					armorTable[level].shardID = reagentID[shardName]
				end
			else
				armorTable[level] = newTable
			end

		end

		disenchantTable.Armor = armorTable
	end


	local function DisenchantValue(itemID)
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType = GetItemInfo(itemID)
		local tableName

		if itemName then
			if itemRarity == Uncommon then
				tableName = itemType
			else
				tableName = itemRarity
			end

			if disenchantTable[tableName] and  disenchantTable[tableName][itemLevel] then
				local dt = disenchantTable[tableName][itemLevel]

				local deValue = 0

				if dt.dustID then
					deValue = deValue + (LSW.AuctionValue(dt.dustID) or 0) * dt.dustCount
				end

				if dt.essenceID then
					deValue = deValue + (LSW.AuctionValue(dt.essenceID) or 0) * dt.essenceCount
				end

				if dt.shardID then
					deValue = deValue + (LSW.AuctionValue(dt.shardID) or 0) * dt.shardCount
				end

				return deValue
			end
		end
	end


	local function Init()
--		LSW:ChatMessage("LilSparky's Workshop adding native Disenchanting support")

		BuildReagentTables()

		LSW.disenchantValue = DisenchantValue
	end


	local function Test(index)
		if enabled then
			return true
		end

		return false
	end

	LSW:RegisterPricingSupport("Disenchanting", Test, Init)
end


